import { BaseHistory, HistoryLocation } from './base';
import { NavigationCallback, HistoryState } from './base';
export declare class HTML5History extends BaseHistory {
    private history;
    private _popStateHandler;
    private _listeners;
    private _teardowns;
    private pauseState;
    constructor();
    ensureLocation(): void;
    replace(to: HistoryLocation): void;
    push(to: HistoryLocation, data?: HistoryState): void;
    back(triggerListeners?: boolean): void;
    forward(triggerListeners?: boolean): void;
    listen(callback: NavigationCallback): () => void;
    /**
     * Remove all listeners attached to the history and cleanups the history
     * instance
     */
    destroy(): void;
    /**
     * Setups the popstate event listener. It's important to setup only
     * one to ensure the same parameters are passed to every listener
     */
    private setupPopStateListener;
    private pauseListeners;
}
