import { RouteRecord, MatcherLocation, MatcherLocationNormalized, MatcherLocationRedirect } from './types/index';
export declare class RouterMatcher {
    private matchers;
    constructor(routes: RouteRecord[]);
    private addRouteRecord;
    /**
     * Resolve a location without doing redirections so it can be used for anchors
     */
    resolveAsPath(): void;
    /**
     * Transforms a MatcherLocation object into a normalized location
     * @param location MatcherLocation to resolve to a url
     */
    resolve(location: Readonly<MatcherLocation>, currentLocation: Readonly<MatcherLocationNormalized>): MatcherLocationNormalized | MatcherLocationRedirect;
}
