import { BaseHistory, HistoryLocation, HistoryLocationNormalized, NavigationDirection } from './base';
import { NavigationCallback, HistoryState } from './base';
export declare class AbstractHistory extends BaseHistory {
    protected listeners: NavigationCallback[];
    queue: HistoryLocationNormalized[];
    position: number;
    constructor();
    ensureLocation(): void;
    replace(to: HistoryLocation): void;
    push(to: HistoryLocation, data?: HistoryState): void;
    listen(callback: NavigationCallback): () => void;
    location: HistoryLocationNormalized;
    back(triggerListeners?: boolean): void;
    forward(triggerListeners?: boolean): void;
    destroy(): void;
    protected triggerListeners(to: HistoryLocationNormalized, from: HistoryLocationNormalized, { direction }: {
        direction: NavigationDirection;
    }): void;
}
