declare type LocationQueryValue = string | null;
declare type LocationQueryValueRaw = LocationQueryValue | number | undefined;
export declare type LocationQuery = Record<string, LocationQueryValue | LocationQueryValue[]>;
export declare type LocationQueryRaw = Record<string | number, LocationQueryValueRaw | LocationQueryValueRaw[]>;
/**
 * Transform a queryString into a query object. Accept both, a version with the leading `?` and without
 * Should work as URLSearchParams
 * @param search
 * @returns a query object
 */
export declare function parseQuery(search: string): LocationQuery;
/**
 * Stringify an object query. Works like URLSearchParams. Doesn't prepend a `?`
 * @param query
 */
export declare function stringifyQuery(query: LocationQueryRaw): string;
/**
 * Transforms a RawQuery intoe a NormalizedQuery by casting numbers into
 * strings, removing keys with an undefined value and replacing undefined with
 * null in arrays
 * @param query
 */
export declare function normalizeQuery(query: LocationQueryRaw): LocationQuery;
export {};
