"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("./index");
const errors_1 = require("../errors");
function guardToPromiseFn(guard, to, from) {
    return () => new Promise((resolve, reject) => {
        const next = (valid) => {
            // TODO: handle callback
            if (valid === false)
                reject(new errors_1.NavigationAborted(to, from));
            else if (index_1.isRouteLocation(valid)) {
                reject(new errors_1.NavigationGuardRedirect(to, valid));
            }
            else
                resolve();
        };
        guard(to, from, next);
    });
}
exports.guardToPromiseFn = guardToPromiseFn;
//# sourceMappingURL=guardToPromiseFn.js.map