"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const guardToPromiseFn_1 = require("./guardToPromiseFn");
__export(require("./guardToPromiseFn"));
async function extractComponentsGuards(matched, guardType, to, from) {
    const guards = [];
    await Promise.all(matched.map(async (record) => {
        // TODO: cache async routes per record
        if ('component' in record) {
            const { component } = record;
            const resolvedComponent = await (typeof component === 'function'
                ? component()
                : component);
            const guard = resolvedComponent[guardType];
            if (guard) {
                guards.push(guardToPromiseFn_1.guardToPromiseFn(guard, to, from));
            }
        }
        else {
            for (const name in record.components) {
                const component = record.components[name];
                const resolvedComponent = await (typeof component === 'function'
                    ? component()
                    : component);
                const guard = resolvedComponent[guardType];
                if (guard) {
                    guards.push(guardToPromiseFn_1.guardToPromiseFn(guard, to, from));
                }
            }
        }
    }));
    return guards;
}
exports.extractComponentsGuards = extractComponentsGuards;
function isRouteLocation(route) {
    return typeof route === 'string' || (route && typeof route === 'object');
}
exports.isRouteLocation = isRouteLocation;
//# sourceMappingURL=index.js.map